dwg.ru forum rss xml
| Правила | Регистрация | Пользователи | Поиск | Сообщения за день | Все разделы прочитаны |  Справка по форуму |

Вернуться   Форум DWG.RU > Программное обеспечение > Программирование > Автопостроение линии поверх указанной, но длинее на заданную величину

Автопостроение линии поверх указанной, но длинее на заданную величину

Версия для печати
 
Ответ
Опции темы Поиск в этой теме
Непрочитано 31.01.2017, 21:31
Автопостроение линии поверх указанной, но длинее на заданную величину
dozZzer
 
Регистрация: 31.01.2017
Сообщений: 5

dozZzer вне форума Вставить имя

Всем привет!
Заранее прошу не пинать, я тут недавно
Вроде бы простая задача, но не нашел по поиску.
В общем имеем 2D линии или полилинии, прямогольники, и хотелось бы такой скрипт, чтобы при клике по линии или стороне прямоугольника поверх нее отрисовывавалсь линия с теми же свойствами выбранного объекта, но длиннее на 1.5" c каждой стороны, т.е. привязка центр-центр и вдоль.
В моём случае это нужно дла разбивки воздуховодов и показа, что это фланцевое соединение (TDC). Может еще какое применение можно придумать.
Величину удлинения можно пока сделать фиксированной.
Кто бы смог такой скрипт написать?
Заранее спасибо за помощь и с меня +
Просмотров: 3177
 
Непрочитано 02.02.2017, 20:19
#21
zamtmn

КИПиА
 
Регистрация: 21.03.2005
Tyumen
Сообщений: 1,350
Отправить сообщение для zamtmn с помощью ICQ


Я изначально не увидел Length+1.5",0,0 поэтому
>>Где в этом алгоритме можно налажать не представляю, но если будет не получаться, спрашивайте.
воспринял в штыки. Уже извинился.
Часто тут вижу подобные решения - чтоб получить чтото элементарное предлагается делать совсем не элементарное... Простейшие геометрические представления у местных обитателей должны быть, без них каши не сваришь

Последний раз редактировалось zamtmn, 02.02.2017 в 20:59.
zamtmn на форуме вставить имя Обратить внимание модератора на это сообщение  
 
Непрочитано 02.02.2017, 20:38
#22
Boxa

КЖ; C#
 
Регистрация: 03.11.2005
Санкт-Петербург
Сообщений: 1,331


Давеча тут один конструктор вершину параболы брутфорсом искал, а Вы про вектора...
Дальше будет ещё лучше, сам так привык к библиотекам, что не сразу сообразил что от векторов можно к флоутам перейти.

Тем временем автор топика молчит

ЗЫ.
Цитата:
Сообщение от zamtmn Посмотреть сообщение
P2=P1+L // новая точка концы
поправьте очипятку.

Последний раз редактировалось Boxa, 03.02.2017 в 06:27. Причина: ЗЫ добавил
Boxa на форуме вставить имя Обратить внимание модератора на это сообщение  
 
Автор темы   Непрочитано 08.02.2017, 00:31
#23
dozZzer


 
Регистрация: 31.01.2017
Сообщений: 5


Всем спасибо за бурное обсуждени! Всё очень интересно и захватывающе, но имеет место быть жуткая нехватка времени это воплотить в жизнь, к сожалению.
Если кто поможет написать, то я смогу потестить или может даже потом доработать.
Заранее благодарю!
dozZzer вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Автор темы   Непрочитано 07.03.2017, 16:48
#24
dozZzer


 
Регистрация: 31.01.2017
Сообщений: 5


Попробовал скрипт из поста #10, линия отрисовывается длиной на 3" больше, но со смещением вверх и влево, а не поверх исходной (это если линия горизонтальная или наклонная). Если вертикальная, то отрисовка происходит справа на расстоянии 60.5". Если по грани прямоугольника клацнкть, то рисует копию прямоугольника справа на расстоянии 5.5".
Спасибо большое уважаемому VVA! Еще бы поправить так, чтоб работало правильно, особенно важно чтоб вдоль стороны прямоугольника работало! Заранее благодарю!
dozZzer вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Непрочитано 13.03.2017, 10:40
1 | #25
Vladimir_Sergeevich

рисую дороги, в перерывах курю Lisp
 
Регистрация: 20.04.2011
Пермь
Сообщений: 332
Отправить сообщение для Vladimir_Sergeevich с помощью ICQ Отправить сообщение для Vladimir_Sergeevich с помощью Skype™


Я тоже давно писал на турбо паскале, но VBA даже не пытался учить. сейчас постепенно постигаю .net
С точки зрения начала, Lisp будет проще, и функционал весьма богатый.
Предлагаю лисповский алгоритм. (не командный)
1 получаем объект entsel
2 анализируем выбранный объект (отрезок, полилиния) и начинаем ветвление (предполагаю будет cond)
3,1 для отрезка получаем начальную конечную точку,
3,2 для полилинии (тут бы проверить bulge) получаем начало конец сегмента (см функции vlax-curve-get...)
4. считаем новые точки с помоoщю (polar pt1 ang dist)
5. строим отрезок/полилинию по полученным точкам. тут же забить слой/цвет/вкус/запах либо по объекту хозяина, либо "как надо"

В дальнейшем весь код можно зациклить на выборе объекта для удобства...

имхо, чем крут Lisp - куски кода можно тестить прямо в командной строке и не надо никаких энейблеров. А изучение COM-модели с помощью (vlax-dump-object (vlax-get-acad-object)) и дальше вниз по иерархии - дико удобно.
__________________
Не труд сделал из обезьяны человека, а лень и жажда халявы...
Vladimir_Sergeevich вне форума вставить имя Обратить внимание модератора на это сообщение  
Ответ
Вернуться   Форум DWG.RU > Программное обеспечение > Программирование > Автопостроение линии поверх указанной, но длинее на заданную величину

Инженерные консультации
Опции темы Поиск в этой теме
Поиск в этой теме:

Расширенный поиск

Быстрый переход

Похожие темы
Тема Автор Раздел Ответов Последнее сообщение
Можно ли назначить красные линии, имея только КПТ? Modis Прочее. Архитектура и строительство 13 15.09.2016 08:55
Autocad 2010. При наложении линии поверх другой, очертание линий не видно. abcdlv AutoCAD 13 02.11.2012 12:56
Толщина засечки размерной линии на строительных чертежах Hooliganka Поиск литературы, чертежей, моделей и прочих материалов 51 01.06.2012 07:27
Как сгладить 2 линии. Или как сгладить только часть линии. Димас AutoCAD 3 14.03.2006 08:28

|| Главная || Каталог САПР || Тендеры || Публикации || Объявления || Биржа труда || Download || Галерея ||
|| Библиотека || Кунсткамера || Каталог предприятий || Контакты || Файлообменник || Блоги ||


Размещение рекламы